.486
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

WinMain proto
MainWndProc proto :DWORD,:DWORD,:DWORD,:DWORD
Resize proto
AddListHScroll proto

.data
	szClassName BYTE "ListBoxDemoMainWnd",0
	AppName BYTE "ListBoxDemo",0

	MainWndText BYTE "Click on the window and resize it so the list box scrollbar could be visible",0

	ListBoxClass BYTE "ListBox",0

	space BYTE " ",0

	LbData1 BYTE "ListBoxDemoStr",0
	LbData2 BYTE "List Box Demo Longer String",0

.data?
	hInstance DWORD ?

	MainWnd DWORD ?
	LbWnd DWORD ?

.code

WinMain proc
	local wcex:WNDCLASSEX
	local msg:MSG

	invoke GetModuleHandle,NULL
	mov hInstance,eax

	invoke InitCommonControls

	mov wcex.cbSize,sizeof WNDCLASSEX
	mov wcex.style,NULL
	mov wcex.lpfnWndProc,offset MainWndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,DLGWINDOWEXTRA

	push hInstance
	pop wcex.hInstance

	mov wcex.lpszMenuName,NULL
	mov wcex.hbrBackground,COLOR_BTNFACE+1
	mov wcex.lpszClassName,offset szClassName
	mov wcex.hIcon,NULL
	mov wcex.hIconSm,NULL

	invoke LoadCursor,NULL,IDC_ARROW
	mov wcex.hCursor,eax

	invoke RegisterClassEx,addr wcex

	invoke CreateWindowEx,NULL,addr szClassName,addr MainWndText,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL

	invoke ShowWindow,MainWnd,SW_SHOW
	invoke UpdateWindow,MainWnd

	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
		.break .if eax==0

		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw

	invoke ExitProcess,msg.wParam
	ret
WinMain endp

MainWndProc proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.if uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg==WM_CREATE
		push hWnd
		pop MainWnd

		invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr ListBoxClass,NULL,WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or WS_HSCROLL or WS_VSCROLL or LBS_NOINTEGRALHEIGHT,0,0,0,0,hWnd,NULL,hInstance,NULL
		mov LbWnd,eax
	.elseif uMsg==WM_LBUTTONUP
		invoke SendMessage,LbWnd,LB_ADDSTRING,0,addr LbData1
		invoke SendMessage,LbWnd,LB_ADDSTRING,0,addr LbData2

		;each time you add a list item you have to call this function
		invoke AddListHScroll
	.elseif uMsg==WM_SIZE
		invoke Resize
	.else
defwndproc:
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
MainWndProc endp

Resize proc
	local rt:RECT

	invoke GetClientRect,MainWnd,addr rt

	mov ecx,rt.bottom
	sub ecx,20
	invoke MoveWindow,LbWnd,0,20,rt.right,ecx,TRUE

	ret
Resize endp

;this function works with any font or font size, what it does is basically to get the longest item in the listbox
;and then calculate its len (in pixels) and then tells the listbox in what len it has to display the scrollbar.
AddListHScroll proc
	local ItemCount:DWORD		;list box item count
	local nItem:DWORD		;item that it's being checked
	local LongerItem:DWORD		;longer item index
	local LongerItemLen:DWORD	;longer item text len
	local hDC:DWORD			;tmp device context
	local lpStr:PTR BYTE		;pointer to the str that holds the longer item text
	local pt:POINT			;size of the str in pixels

	mov LongerItem,0
	mov nItem,0

	invoke SendMessage,LbWnd,LB_GETCOUNT,0,0
	or eax,eax
	jz exit
	mov ItemCount,eax

	invoke SendMessage,LbWnd,LB_GETTEXTLEN,LongerItem,0
	mov LongerItemLen,eax

@@:
	mov eax,nItem
	.if eax<ItemCount
		invoke SendMessage,LbWnd,LB_GETTEXTLEN,nItem,0
		.if sdword ptr eax>LongerItemLen
			push nItem
			pop LongerItem

			invoke SendMessage,LbWnd,LB_GETTEXTLEN,LongerItem,0
			mov LongerItemLen,eax
		.endif

		inc nItem
		jmp @B		
	.endif

	invoke GetDC,NULL
	mov hDC,eax

	invoke SendMessage,LbWnd,WM_GETFONT,0,0
	invoke SelectObject,hDC,eax

	invoke SendMessage,LbWnd,LB_GETTEXTLEN,LongerItem,0
	add eax,2
	invoke GlobalAlloc,GMEM_FIXED,eax
	mov lpStr,eax
	invoke SendMessage,LbWnd,LB_GETTEXT,LongerItem,lpStr
	invoke lstrcat,lpStr,addr space

	invoke lstrlen,lpStr
	mov LongerItemLen,eax
	invoke GetTextExtentPoint32,hDC,lpStr,LongerItemLen,addr pt

	invoke GlobalFree,lpStr

	invoke ReleaseDC,NULL,hDC

	invoke SendMessage,LbWnd,LB_SETHORIZONTALEXTENT,pt.x,0

exit:
	ret
AddListHScroll endp

end WinMain
